BIND 9

	BIND version 9 is a major rewrite of nearly all aspects of the
	underlying BIND architecture.  Some of the important features of
	BIND 9 are:

		- DNS Security
			DNSSEC (signed zones)
			TSIG (signed DNS requests)

		- IP version 6
			Answers DNS queries on IPv6 sockets
			IPv6 resource records (AAAA)
			Experimental IPv6 Resolver Library

		- DNS Protocol Enhancements
			IXFR, DDNS, Notify, EDNS0
			Improved standards conformance

		- Views
			One server process can provide multiple "views" of
			the DNS namespace, e.g. an "inside" view to certain
			clients, and an "outside" view to others.

		- Multiprocessor Support

		- Improved Portability Architecture


	BIND version 9 development has been underwritten by the following
	organizations:

		Sun Microsystems, Inc.
		Hewlett Packard
		Compaq Computer Corporation
		IBM
		Process Software Corporation
		Silicon Graphics, Inc.
		Network Associates, Inc.
		U.S. Defense Information Systems Agency
		USENIX Association
		Stichting NLnet - NLnet Foundation
		Nominum, Inc.

	For a summary of functional enhancements in previous
	releases, see the HISTORY file.

	For a detailed list of user-visible changes from
	previous releases, see the CHANGES file.

	For up-to-date release notes and errata, see
	http://www.isc.org/software/bind9/releasenotes

BIND 9.11.0

	BIND 9.11.0 includes a number of changes from BIND 9.10 and earlier
	releases.  New features include:

	- The EDNS Client Subnet (ECS) option is now supported for
	  authoritative servers; if a query contains an ECS option
	  then ACLs containing "geoip" or "ecs" elements can match
	  against the the address encoded in the option.  This can be
	  used to select a view for a query, so that different answers
	  can be provided depending on the client network.
	- The EDNS EXPIRE option has been implemented on the client
	  side, allowing a slave server to set the expiration timer
	  correctly when transferring zone data from another slave
	  server.
	- A new "masterfile-style" zone option controls the formatting
	  of text zone files:  When set to "full", a zone file is dumped
	  in single-line-per-record format.
	- "dig" now supports sending arbitary EDNS options by specifying
	  them on the command line.
	- "dig +ttlunits" causes dig to print TTL values with time-unit
	  suffixes: w, d, h, m, s for weeks, days, hours, minutes, and
	  seconds.
	- "serial-update-format" can now be set to "date". On update,
	  the serial number will be set to the current date in YYYYMMDDNN
	  format.
	- "dnssec-signzone -N date" sets the serial number to YYYYMMDDNN.
	- "named -L <filename>" causes named to send log messages to
	   the specified file by default instead of to the system log.

	This release addresses the security flaw described in
	CVE-2014-3214 and CVE-2014-3859.

BIND 9.10.0

	BIND 9.10.0 includes a number of changes from BIND 9.9 and earlier
	releases.  New features include:

	 - DNS Response-rate limiting (DNS RRL), which blunts the
	   impact of reflection and amplification attacks, is always
	   compiled in and no longer requires a compile-time option
	   to enable it.
	 - An experimental "Source Identity Token" (SIT) EDNS option
	   is now available.  Similar to DNS Cookies as invented by
	   Donald Eastlake 3rd, these are designed to enable clients
	   to detect off-path spoofed responses, and to enable servers
	   to detect spoofed-source queries.  Servers can be configured
	   to send smaller responses to clients that have not identified
	   themselves using a SIT option, reducing the effectiveness of
	   amplification attacks.  RRL processing has also been updated;
	   clients proven to be legitimate via SIT are not subject to
	   rate limiting.  Use "configure --enable-sit" to enable this
	   feature in BIND.
	 - A new zone file format, "map", stores zone data in a
	   format that can be mapped directly into memory, allowing
	   significantly faster zone loading.
	 - "delv" (domain entity lookup and validation) is a new tool
	   with dig-like semantics for looking up DNS data and performing
	   internal DNSSEC validation.  This allows easy validation in
	   environments where the resolver may not be trustworthy, and
	   assists with troubleshooting of DNSSEC problems. (NOTE:
	   In previous development releases of BIND 9.10, this utility
	   was called "delve". The spelling has been changed to avoid
	   confusion with the "delve" utility included with the Xapian
	   search engine.)
	 - Improved EDNS(0) processing for better resolver performance
	   and reliability over slow or lossy connections.
	 - A new "configure --with-tuning=large" option tunes certain
	   compiled-in constants and default settings to values better
	   suited to large servers with abundant memory.  This can
	   improve performance on such servers, but will consume more
	   memory and may degrade performance on smaller systems.
	 - Substantial improvement in response-policy zone (RPZ)
	   performance.  Up to 32 response-policy zones can be
	   configured with minimal performance loss.
	 - To improve recursive resolver performance, cache records
	   which are still being requested by clients can now be
	   automatically refreshed from the authoritative server
	   before they expire, reducing or eliminating the time
	   window in which no answer is available in the cache.
	 - New "rpz-client-ip" triggers and drop policies allowing
	   response policies based on the IP address of the client.
	 - ACLs can now be specified based on geographic location
	   using the MaxMind GeoIP databases.  Use "configure
	   --with-geoip" to enable.
	 - Zone data can now be shared between views, allowing
	   multiple views to serve the same zones authoritatively
	   without storing multiple copies in memory.
	 - New XML schema (version 3) for the statistics channel
	   includes many new statistics and uses a flattened XML tree
	   for faster parsing. The older schema is now deprecated.
	 - A new stylesheet, based on the Google Charts API, displays
	   XML statistics in charts and graphs on javascript-enabled
	   browsers.
	 - The statistics channel can now provide data in JSON
	   format as well as XML.
	 - New stats counters track TCP and UDP queries received
	   per zone, and EDNS options received in total.
	 - The internal and export versions of the BIND libraries
	   (libisc, libdns, etc) have been unified so that external
	   library clients can use the same libraries as BIND itself.
	 - A new compile-time option, "configure --enable-native-pkcs11",
	   allows BIND 9 cryptography functions to use the PKCS#11 API
	   natively, so that BIND can drive a cryptographic hardware
	   service module (HSM) directly instead of using a modified
	   OpenSSL as an intermediary. (Note: This feature requires an
	   HSM to have a full implementation of the PKCS#11 API; many
	   current HSMs only have partial implementations. The new
	   "pkcs11-tokens" command can be used to check API completeness.
	   Native PKCS#11 is known to work with the Thales nShield HSM
	   and with SoftHSM version 2 from the Open DNSSEC project.)
	 - The new "max-zone-ttl" option enforces maximum TTLs for
	   zones. This can simplify the process of rolling DNSSEC keys
	   by guaranteeing that cached signatures will have expired
	   within the specified amount of time.
	 - "dig +subnet" sends an EDNS CLIENT-SUBNET option when
	   querying.
	 - "dig +expire" sends an EDNS EXPIRE option when querying.
	   When this option is sent with an SOA query to a server
	   that supports it, it will report the expiry time of
	   a slave zone.
	 - New "dnssec-coverage" tool to check DNSSEC key coverage
	   for a zone and report if a lapse in signing coverage has
	   been inadvertently scheduled.
	 - Signing algorithm flexibility and other improvements
	   for the "rndc" control channel.
	 - "named-checkzone" and "named-compilezone" can now read
	   journal files, allowing them to process dynamic zones.
	 - Multiple DLZ databases can now be configured.  Individual
	   zones can be configured to be served from a specific DLZ
	   database.  DLZ databases now serve zones of type "master"
	   and "redirect".
	 - "rndc zonestatus" reports information about a specified zone.
	 - "named" now listens on IPv6 as well as IPv4 interfaces
	   by default.
	 - "named" now preserves the capitalization of names
	   when responding to queries: for instance, a query for
	   "example.com" may be answered with "example.COM" if the
	   name was configured that way in the zone file.  Some
	   clients have a bug causing them to depend on the older
	   behavior, in which the case of the answer always matched
	   the case of the query, rather than the case of the name
	   configured in the DNS.  Such clients can now be specified
	   in the new "no-case-compress" ACL; this will restore the
	   older behavior of "named" for those clients only.
	 - new "dnssec-importkey" command allows the use of offline
	   DNSSEC keys with automatic DNSKEY management.
	 - New "named-rrchecker" tool to verify the syntactic
	   correctness of individual resource records.
	 - When re-signing a zone, the new "dnssec-signzone -Q" option
	   drops signatures from keys that are still published but are
	   no longer active.
	 - "named-checkconf -px" will print the contents of configuration
	   files with the shared secrets obscured, making it easier to
	   share configuration (e.g. when submitting a bug report)
	   without revealing private information.
	 - "rndc scan" causes named to re-scan network interfaces for
	   changes in local addresses.
	 - On operating systems with support for routing sockets,
	   network interfaces are re-scanned automatically whenever
	   they change.
	 - "tsig-keygen" is now available as an alternate command
	   name to use for "ddns-confgen".

Building

	BIND 9 currently requires a UNIX system with an ANSI C compiler,
	basic POSIX support, and a 64 bit integer type.

	We've had successful builds and tests on the following systems:

		COMPAQ Tru64 UNIX 5.1B
		Fedora Core 6
		FreeBSD 4.10, 5.2.1, 6.2
		HP-UX 11.11
		Mac OS X 10.5
		NetBSD 3.x, 4.0-beta, 5.0-beta
		OpenBSD 3.3 and up
		Solaris 8, 9, 9 (x86), 10
		Ubuntu 7.04, 7.10
		Windows XP/2003/2008

	NOTE:  As of BIND 9.5.1, 9.4.3, and 9.3.6, older versions of
	Windows, including Windows NT and Windows 2000, are no longer
	supported.

	We have recent reports from the user community that a supported
	version of BIND will build and run on the following systems:

		AIX 4.3, 5L
		CentOS 4, 4.5, 5
		Darwin 9.0.0d1/ARM
		Debian 4, 5, 6
		Fedora Core 5, 7, 8
		FreeBSD 6, 7, 8
		HP-UX 11.23 PA
		MacOS X 10.5, 10.6, 10.7
		Red Hat Enterprise Linux 4, 5, 6
		SCO OpenServer 5.0.6
		Slackware 9, 10
		SuSE 9, 10

	To build, just

		./configure
		make

	Do not use a parallel "make".

	Several environment variables that can be set before running
	configure will affect compilation:

	    CC
		The C compiler to use.  configure tries to figure
		out the right one for supported systems.

	    CFLAGS
		C compiler flags.  Defaults to include -g and/or -O2
		as supported by the compiler.  Please include '-g'
		if you need to set CFLAGS.

	    STD_CINCLUDES
		System header file directories.  Can be used to specify
		where add-on thread or IPv6 support is, for example.
		Defaults to empty string.

	    STD_CDEFINES
		Any additional preprocessor symbols you want defined.
		Defaults to empty string.

		Possible settings:
		Change the default syslog facility of named/lwresd.
		  -DISC_FACILITY=LOG_LOCAL0
		Enable DNSSEC signature chasing support in dig.
		  -DDIG_SIGCHASE=1 (sets -DDIG_SIGCHASE_TD=1 and
				    -DDIG_SIGCHASE_BU=1)
		Disable dropping queries from particular well known ports.
		  -DNS_CLIENT_DROPPORT=0
		Sibling glue checking in named-checkzone is enabled by default.
		To disable the default check set.  -DCHECK_SIBLING=0
		named-checkzone checks out-of-zone addresses by default.
		To disable this default set.  -DCHECK_LOCAL=0
		To create the default pid files in ${localstatedir}/run rather
		than ${localstatedir}/run/{named,lwresd}/ set.
		  -DNS_RUN_PID_DIR=0
		Enable workaround for Solaris kernel bug about /dev/poll
		  -DISC_SOCKET_USE_POLLWATCH=1
		  The watch timeout is also configurable, e.g.,
		  -DISC_SOCKET_POLLWATCH_TIMEOUT=20

	    LDFLAGS
		Linker flags. Defaults to empty string.

	The following need to be set when cross compiling.

	    BUILD_CC
		The native C compiler.
	    BUILD_CFLAGS (optional)
	    BUILD_CPPFLAGS (optional)
		Possible Settings:
		-DNEED_OPTARG=1         (optarg is not declared in <unistd.h>)
	    BUILD_LDFLAGS (optional)
	    BUILD_LIBS (optional)

	On most platforms, BIND 9 is built with multithreading
	support, allowing it to take advantage of multiple CPUs.
	You can configure this by specifying "--enable-threads" or
	"--disable-threads" on the configure command line.  The default
	is to enable threads, except on some older operating systems
	on which threads are known to have had problems in the past.
	(Note: Prior to BIND 9.10, the default was to disable threads on
	Linux systems; this has been reversed.  On Linux systems, the
	threaded build is known to change BIND's behavior with respect
	to file permissions; it may be necessary to specify a user with
	the -u option when running named.)

	To build shared libraries, specify "--with-libtool" on the
	configure command line.

	Certain compiled-in constants and default settings can be
	increased to values better suited to large servers with abundant
	memory resources (e.g, 64-bit servers with 12G or more of memory)
	by specifying "--with-tuning=large" on the configure command
	line. This can improve performance on big servers, but will
	consume more memory and may degrade performance on smaller
	systems.

	For the server to support DNSSEC, you need to build it
	with crypto support.  You must have OpenSSL 0.9.5a
	or newer installed and specify "--with-openssl" on the
	configure command line.  If OpenSSL is installed under
	a nonstandard prefix, you can tell configure where to
	look for it using "--with-openssl=/prefix".

	To support the HTTP statistics channel, the server must
	be linked with at least one of the following: libxml2
	(http://xmlsoft.org) or json-c (https://github.com/json-c).
	If these are installed at a nonstandard prefix, use
	"--with-libxml2=/prefix" or "--with-libjson=/prefix".

	On some platforms it is necessary to explicitly request large
	file support to handle files bigger than 2GB.  This can be
	done by "--enable-largefile" on the configure command line.

	Support for the "fixed" rrset-order option can be enabled
	or disabled by specifying "--enable-fixed-rrset" or
	"--disable-fixed-rrset" on the configure command line.
	The default is "disabled", to reduce memory footprint.

	If your operating system has integrated support for IPv6, it
	will be used automatically.  If you have installed KAME IPv6
	separately, use "--with-kame[=PATH]" to specify its location.

	"make install" will install "named" and the various BIND 9 libraries.
	By default, installation is into /usr/local, but this can be changed
	with the "--prefix" option when running "configure".

	You may specify the option "--sysconfdir" to set the directory
	where configuration files like "named.conf" go by default,
	and "--localstatedir" to set the default parent directory
	of "run/named.pid".   For backwards compatibility with BIND 8,
	--sysconfdir defaults to "/etc" and --localstatedir defaults to
	"/var" if no --prefix option is given.  If there is a --prefix
	option, sysconfdir defaults to "$prefix/etc" and localstatedir
	defaults to "$prefix/var".

	To see additional configure options, run "configure --help".
	Note that the help message does not reflect the BIND 8
	compatibility defaults for sysconfdir and localstatedir.

	If you're planning on making changes to the BIND 9 source, you
	should also "make depend".  If you're using Emacs, you might find
	"make tags" helpful.

	If you need to re-run configure please run "make distclean" first.
	This will ensure that all the option changes take.

	Building with gcc is not supported, unless gcc is the vendor's usual
	compiler (e.g. the various BSD systems, Linux).

	Known compiler issues:
	* gcc-3.2.1 and gcc-3.1.1 is known to cause problems with solaris-x86.
	* gcc prior to gcc-3.2.3 ultrasparc generates incorrect code at -02.
	* gcc-3.3.5 powerpc generates incorrect code at -02.
	* Irix, MipsPRO 7.4.1m is known to cause problems.

	A limited test suite can be run with "make test".  Many of
	the tests require you to configure a set of virtual IP addresses
	on your system, and some require Perl; see bin/tests/system/README
	for details.

	SunOS 4 requires "printf" to be installed to make the shared
	libraries.  sh-utils-1.16 provides a "printf" which compiles
	on SunOS 4.

Known limitations

	Linux requires kernel build 2.6.39 or later to get the
	performance benefits from using multiple sockets.

Documentation

	The BIND 9 Administrator Reference Manual is included with the
	source distribution in DocBook XML and HTML format, in the
	doc/arm directory.

	Some of the programs in the BIND 9 distribution have man pages
	in their directories.  In particular, the command line
	options of "named" are documented in /bin/named/named.8.
	There is now also a set of man pages for the lwres library.

	If you are upgrading from BIND 8, please read the migration
	notes in doc/misc/migration.  If you are upgrading from
	BIND 4, read doc/misc/migration-4to9.

	Frequently asked questions and their answers can be found in
	FAQ.

	Additional information on various subjects can be found
	in the other README files.


Change Log

	A detailed list of all changes to BIND 9 is included in the
	file CHANGES, with the most recent changes listed first.
	Change notes include tags indicating the category of the
	change that was made; these categories are:

	   [func]         New feature

	   [bug]          General bug fix

	   [security]     Fix for a significant security flaw

	   [experimental] Used for new features when the syntax
			  or other aspects of the design are still
			  in flux and may change

	   [port]         Portability enhancement

	   [maint]        Updates to built-in data such as root
			  server addresses and keys

	   [tuning]       Changes to built-in configuration defaults
			  and constants to improve performance

	   [protocol]     Updates to the DNS protocol such as new
			  RR types

	   [test]         Changes to the automatic tests, not
			  affecting server functionality

	   [cleanup]      Minor corrections and refactoring

	   [doc]          Documentation

	   [contrib]	  Changes to the contributed tools and
			  libraries in the 'contrib' subdirectory

	   [placeholder]  Used in the master development branch to
			  reserve change numbers for use in other
			  branches, e.g. when fixing a bug that only
			  exists in older releases

	In general, [func] and [experimental] tags will only appear
	in new-feature releases (i.e., those with version numbers
	ending in zero).  Some new functionality may be backported to
	older releases on a case-by-case basis.  All other change
	types may be applied to all currently-supported releases.


Bug Reports and Mailing Lists

	Bugs reports should be sent to

		bind9-bugs@isc.org

	To join the BIND Users mailing list, send mail to

		bind-users-request@isc.org

	archives of which can be found via

		http://www.isc.org/ops/lists/

	If you're planning on making changes to the BIND 9 source
	code, you might want to join the BIND Workers mailing list.
	Send mail to

		bind-workers-request@isc.org


Acknowledgments

	- This product includes software developed by the OpenSSL Project
	  for use in the OpenSSL Toolkit. (http://www.OpenSSL.org/).
	- This product includes cryptographic software written by Eric
	  Young (eay@cryptsoft.com).
	- This product includes software written by Tim Hudson
	  (tjh@cryptsoft.com).
